package my.project.design;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.gmf.runtime.draw2d.ui.figures.IBorderItemLocator;
import org.eclipse.sirius.diagram.DDiagramElement;
import org.eclipse.sirius.diagram.business.api.query.DDiagramElementQuery;
import org.eclipse.sirius.diagram.ui.tools.api.graphical.edit.styles.BorderItemLocatorProvider;
import org.eclipse.sirius.diagram.ui.tools.api.graphical.edit.styles.IBorderItemOffsets;

import basicfamily.Man;
import basicfamily.Woman;

public class ChildrenItemLocationProvider implements BorderItemLocatorProvider {

	private static ChildrenItemLocationProvider instance = new ChildrenItemLocationProvider();

	@Override
	public IBorderItemLocator getBorderItemLocator(IFigure figure, DDiagramElement vpElementOwner, DDiagramElement diagramElementBorderItem) {
		final ChildrenBorderItemLocator locator = new ChildrenBorderItemLocator(figure, PositionConstants.NSEW);
		if (new DDiagramElementQuery(diagramElementBorderItem).isIndirectlyCollapsed()) {
			locator.setBorderItemOffset(IBorderItemOffsets.COLLAPSE_FILTER_OFFSET);
		} else {
			locator.setBorderItemOffset(IBorderItemOffsets.DEFAULT_OFFSET);
		}
		if (diagramElementBorderItem.getTarget() instanceof Man) {
			locator.setPreferredSideOfParent(PositionConstants.WEST);
		}
		if (diagramElementBorderItem.getTarget() instanceof Woman) {
			locator.setPreferredSideOfParent(PositionConstants.EAST);
		}
		return locator;
	}

	public static ChildrenItemLocationProvider getInstance() {
		return instance;
	}
	
}
