package my.project.design;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gmf.runtime.diagram.ui.figures.BorderItemLocator;
import org.eclipse.gmf.runtime.draw2d.ui.figures.IBorderItemLocator;
import org.eclipse.sirius.diagram.DNode;
import org.eclipse.sirius.diagram.ui.tools.api.graphical.edit.styles.BorderItemLocatorProvider;
import org.eclipse.sirius.diagram.ui.tools.api.graphical.edit.styles.SimpleStyleConfiguration;

import basicfamily.Man;
import basicfamily.Woman;

public class ChildrenStyleConfiguration extends SimpleStyleConfiguration {

	@Override
	public BorderItemLocatorProvider getBorderItemLocatorProvider() {
		return ChildrenItemLocationProvider.getInstance();
	}

	@Override
	public IBorderItemLocator getNameBorderItemLocator(DNode node, IFigure mainFigure) {
		if (node.getTarget() instanceof Man) {
			BorderItemLocator locator = new BorderItemLocator(mainFigure, PositionConstants.EAST);
			locator.setBorderItemOffset(new Dimension(-5, -2));
			return locator;
		}
		if (node.getTarget() instanceof Woman) {
			BorderItemLocator locator = new BorderItemLocator(mainFigure, PositionConstants.WEST);
			locator.setBorderItemOffset(new Dimension(-5, -2));
			return locator;
		}
		return super.getNameBorderItemLocator(node, mainFigure);
	}

}
